Mercury library 1.0 Translation of CFG grammars into an object model (Bachelor's thesis).

- Main Page
- Packages
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Enumerations Enumerator Properties
Public Member Functions | List of all members
Mercury.Interpreting.InterpreterAction< T, U > Class Template Referenceabstract

Interpreter action with a safer return type. More...

Inheritance diagram for Mercury.Interpreting.InterpreterAction< T, U >:

## Public Member Functions
| InterpreterAction (string name, Tuple< int, int > arity, ArgumentType[] argtypes, bool allowswild=true)
| Initializes a new instance of the InterpreterAction{T,U} class. See Mercury.Interpreting.InterpreterAction{T} for better explanation. More...
abstract U | Evaluate (Argument[] arguments, RecursiveEval< T > eval, InterpreterContext< T > context)
| Evaluates the action. More...
override object | Invoke (Argument[] arguments, RecursiveEval< T > eval, InterpreterContext< T > context)
| Evaluates the arguments. It is guaranteed to have a valid number of arguments (specified by Arity) and that no argument is `null` UNLESS the flag Mercury.Interpreting.ArgumentType contains `Lazy` or `Null`. More...
Public Member Functions inherited from Mercury.Interpreting.InterpreterAction< T >
| InterpreterAction (string name, Tuple< int, int > arity, ArgumentType[] argtypes, bool allowswild=true)
| Initializes a new instance of the InterpreterAction{T} class. The target application can inherit from this class, but rather one of Mercury.Interpreting.InterpreterAction{T,U} or Mercury.Interpreting.GenericAction{T} is recommended to derive. Conditions: More...

## Additional Inherited Members
Protected Member Functions inherited from Mercury.Interpreting.InterpreterAction< T >
void | CheckDefinition ()
Properties inherited from Mercury.Interpreting.InterpreterAction< T >
string | Name`[get, set]`
| Action name. More...
Tuple< int, int > | Arity`[get, set]`
| Minimum and maximum number of arguments. More...
ArgumentType | ReturnType`[get, set]`
| Action return type. More...
ArgumentType[] | ArgumentTypes`[get, set]`
| Allowed types of arguments. If more arguments specified (within range of Arity), the last type in this array will be used. It can be empty if and only if arity is (0,0). More...
bool | AllowsWildcard`[get, set]`
| Indicates whether a Mercury.Interpreting.Wildcard can be an argument of this action. More...

## Detailed Description

Interpreter action with a safer return type.

Template Parameters

  T | Interpreter output type.
  U | Action return type.

Type Constraints

  T | : | class |

Definition at line 157 of file InterpreterAction.cs.

## Constructor & Destructor Documentation

Mercury.Interpreting.InterpreterAction< T, U >.InterpreterAction | ( | string | name,
|  | Tuple< int, int > | arity,
|  | ArgumentType[] | argtypes,
|  | bool | allowswild = `true`
| ) |  |

Initializes a new instance of the InterpreterAction{T,U} class. See Mercury.Interpreting.InterpreterAction{T} for better explanation.

Parameters

  name | The name of action.
  arity | The arity of action.
  argtypes | Argument types.
  allowswild | Indicates whether the action can accept wildcards.

Definition at line 170 of file InterpreterAction.cs.

## Member Function Documentation

abstract U Mercury.Interpreting.InterpreterAction< T, U >.Evaluate | ( | Argument[] | arguments,
|  | RecursiveEval< T > | eval,
|  | InterpreterContext< T > | context
| ) |  |
| pure virtual

Evaluates the action.

Parameters

  arguments | Arguments provided by the interpreter.
  eval | The recursive evaluation delegate.
  context | The interpreter context.

Returns

Implemented in Mercury.Interpreting.ConstantAction< T, U >, Mercury.Interpreting.ConvertAction< T, U, V >, Mercury.Interpreting.FoldingAction< T, U, V >, and Mercury.Interpreting.OperationAction< T, U, V >.

override object Mercury.Interpreting.InterpreterAction< T, U >.Invoke | ( | Argument[] | arguments,
|  | RecursiveEval< T > | eval,
|  | InterpreterContext< T > | context
| ) |  |
| virtual

Evaluates the arguments.
It is guaranteed to have a valid number of arguments (specified by Arity) and that no argument is `null` UNLESS the flag Mercury.Interpreting.ArgumentType contains `Lazy` or `Null`.

Parameters

  arguments | Arguments of the function.
  eval | The recursive evaluation of trees.
  context | Interpreter context.

Returns
  String value of evaluation or `null` if failed.

Implements Mercury.Interpreting.InterpreterAction< T >.

Definition at line 197 of file InterpreterAction.cs.

The documentation for this class was generated from the following file:

- Mercury/Mercury/Interpreting/InterpreterAction.cs